/*
    This file is part of the UNF library / toolset
    Copyright (C) 2000 Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* $RCSfile: OTTC.C $
   $Locker: ska $	$Name:  $	$State: Exp $

	Output a character table with comment.

*/

#include "unf.loc"

#ifdef _MICROC_
#endif

#include "unf_post.loc"

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: OTTC.C 1.1 2000/03/07 03:59:29 ska Exp ska $";
#endif

void ottc(unsigned char *buf, size_t len, char *comment)
{	int i;
	unsigned char *p;
	size_t offset;

	if(len > 7)
		otc(comment);
	offset = 0;
	p = buf;
	while(offset + 8 <= len) {
		otopen();
		for(i = 9; --i;)
			otbf(*p++);
		os("# ");
		for(i = 9; --i; ++buf)
			oc(isviewable(*buf)? *buf: '.');
		of(" @ %5u", offset);
		offset += 8;
		onl();
	}
	if(offset < len) {
		otopen();
		i = len - offset;
		while(i--)
			otbf(*p++);
		i = 8 - (len - offset);
		while(i--)
			os("    ");
		os("# ");
		i = len - offset;
		while(i--) {
			oc(isviewable(*buf)? *buf: '.');
			++buf;
		}
		i = 8 - (len - offset);
		while(i--)
			oc(' ');
		if(len > 7) {
			of(" @ %5u", offset);
			onl();
		}
		else otc(comment);
	}
}
