/*
    This file is part of the UNF library / toolset
    Copyright (C) 2000 Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* $RCSfile: UNF_TAB.C $
   $Locker: ska $	$Name:  $	$State: Exp $

	unf_tab() generates an array of all indexes of each table

	unf_tab(unf_data)[table_id] == index of table_id'th table
			within dynamic array und_data->data[]

	Absent tables are indicated by -1.
	If unf_data->data[] contains the same table twice, the last
	one superceeds the previous one(s).
	The returned array has exactly 256 items.

*/

#include "unf.loc"

#ifdef _MICROC_
#endif
#include <string.h>

#include "unf_post.loc"

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: UNF_TAB.C 1.1 2000/06/17 22:32:13 ska Exp ska $";
#endif

int *unf_tab(struct UNF_DATA *d)
{	int *tab;
	int i;

	tab = unf_alloc(sizeof(int) * 256);
		/* Initialize the whole array with (int)-1 */
	memset(tab, -1, sizeof(int) * 256);

	i = d->numData;
	while(i--) if(d->data[i])
		tab[d->data[i]->fct] = i;

	return tab;
}
